/*
 * GetTranslatedText.java
 *
 * Created on February 24, 2004, 2:40 PM
 */

package com.actuate.ExternalText; 

/** Command line way of testing label interface.
 *
 * @author  jrutherford
 */
public class GetTranslatedText {
    
    /** Creates a new instance of GetTranslatedText */
    public GetTranslatedText() {
    }
    
    /**
     * Command line way of testing label interface.
     * Takes five parameters, and none are optional: <P>
     * 1) Drivername - This is DriverManager class name like "sun.jdbc.odbc.JdbcOdbcDriver" <P>
     * 2) SourceURL - the source URL for the database, as in "jdbc:odbc:sfdataExternLabels" <P>
     * 3) Username - DB username <P>
     * 4) Password - DB password <P>
     * 5) SQLStatement - the SQL text to send for translation <P>
     * Note that this does not test the setAttribute and placeholder substitution functionality.
     * @param args
     */
    public static void main(String args[]) {
        if (args.length != 2 ) {
            System.out.println("Wrong number of parameters");
            System.out.println("Usage: GetTranslatedText ReportName , Locale" );
//            System.out.println("Example: GetTranslatedText \"sun.jdbc.odbc.JdbcOdbcDriver\" \"jdbc:odbc:sfdataExternLabels\" \"user\" \"pass\" \"select * from T_ReportLabels where Locale =\'Spanish\' and ReportName=\'I18NTest\'");
            System.out.println("Example: GetTranslatedText I18NExternTest sp_SP");
        }
        else {
           
            try {
                TextEntryList tlist = new TextEntryList();

                tlist.connectDB( );
                tlist.setAttribute("ReportName" , args[0] );
                tlist.setAttribute("Locale" , args[1] );
                tlist.translate( );
            
                while (tlist.next() ) {
                    System.out.println( "Entry for " + tlist.getString("BaseValue"));
                    System.out.println( "Translated to " + tlist.getString("TranslatedValue"));
                    System.out.println( "Font face is " + tlist.getString("FontFaceName"));
                    System.out.println( "Font Size is " + tlist.getInt("FontSize"));
                    System.out.println( "FieldWidth is " + tlist.getInt("FieldWidth"));
                    System.out.println( "Relative Position is " + tlist.getInt("RelativePosition"));
                }
         
                tlist.disconnectDB();
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }

    }
    
}
