package com.actuate.activeportal.beans;

import com.actuate.activeportal.actions.AcCreateQueryAction;
import com.actuate.activeportal.control.HtmlTree;
import com.actuate.activeportal.control.HtmlTreeNode;
import com.actuate.activeportal.idapiadapter.AcBaseJobAdapter;
import com.actuate.reportcast.utils.AcRequestHandlerBean;
import com.actuate.reportcast.utils.StaticFuncs;
import com.actuate.schemas.*;
import java.io.PrintStream;
import java.io.Serializable;
import java.util.*;
//DJM 3/4/04: Import necessary libraries for external label capability
import java.io.FileNotFoundException;
import java.sql.SQLException;
import java.io.IOException;
import com.actuate.ExternalText.TextEntryList;

// Referenced classes of package com.actuate.activeportal.beans:
//            SummaryBean, TableParameterListBean

public class CreateQueryBean
    implements Serializable
{

    public CreateQueryBean()
    {
        alStructureNames = new LinkedList();
        viewInNewWindow = true;
        promptedNonHiddenParameterCount = 0;
        submitQuery = false;
        scheduleType = "immediate";
        availableColumns = new Vector();
        selectedColumns = new Vector();
        htSelectedColumns = new Hashtable();
        sortColumns = new Vector();
        queryName = "";
        queryLocation = "";
        documentOutputLocation = "other";
        documentLocation = "";
        headline = "";
        progressiveViewing = true;
        priority = 500;
        notify = false;
        notificationAttachment = "no";
        columnsAvailableToGroup = new Vector(10);
        groups = new HtmlTree();
        selectedNode = null;
        summaryColumns = new Vector(10);
        arrayOfParameterValue = new ArrayOfParameterValue();
        query = new Query();
        String s = (new GregorianCalendar()).getTime().toString();
        query.setPromptSelectColumnList(Boolean.TRUE);
        query.setPromptOutputFormat(Boolean.TRUE);
        query.setPromptSortColumnList(Boolean.TRUE);
        query.setOutputFormat("DHTML");
        query.setPageHeader("");
        queryFile = new NewFile();
        queryFile.setReplaceExisting(Boolean.TRUE);
        queryFile.setDescription("");
        newFile = new NewFile();
        newFile.setReplaceExisting(Boolean.TRUE);
    }

    private void processDisplayedTab(int i, int j)
    {
        Vector vector = new Vector();
        if(!forRunning)
        {
            vector.add("content");
            if(Boolean.TRUE == query.getGroupingEnabled())
            {
                vector.add("groups");
                vector.add("summary");
            }
            vector.add("sorting");
            promptFilterPage = getVisibleParameterCount() + columnFilters.length > 0;
            if(promptFilterPage)
                vector.add("filters");
            vector.add("finish");
        } else
        {
            if(Boolean.TRUE == query.getPromptSelectColumnList())
                vector.add("content");
            if(Boolean.TRUE == query.getGroupingEnabled())
            {
                if(Boolean.TRUE == query.getPromptGroupingList())
                    vector.add("groups");
                if(Boolean.TRUE == query.getPromptAggregationList())
                    vector.add("summary");
            }
            if(Boolean.TRUE == query.getPromptSortColumnList())
                vector.add("sorting");
            promptFilterPage = true;
            promptFilterPage = i + j > 0;
            if(promptFilterPage)
                vector.add("filters");
            if(submitQuery)
                vector.add("schedule");
            vector.add("run.finish");
        }
        displayedTabs = (String[])vector.toArray(new String[vector.size()]);
    }

    int findColumn(String s)
    {
        for(int i = 0; i < columnDefinitions.length; i++)
            if(s.equalsIgnoreCase(columnDefinitions[i].getName()))
                return i;

        return -1;
    }

	// DJM 3/4/04: Add findDisplayColumn method to find matched column display name
    int findDisplayColumn(String sDisplayName)
    {
        for(int i = 0; i < columnDefinitions.length; i++)
            if(sDisplayName.equalsIgnoreCase(columnDefinitions[i].getName()))
                return i;

        return -1;
    }

    int findParameter(String s)
    {
        for(int i = 0; i < parameters.length; i++)
            if(null != s && s.equalsIgnoreCase(parameters[i].getName()))
                return i;

        return -1;
    }

    int findFilter(String s)
    {
        for(int i = 0; i < filters.length; i++)
            if(null != s && s.equalsIgnoreCase(filters[i].getName()))
                return i;

        return -1;
    }

    private void dbg(String s)
    {
        String s1 = getClass().getName();
        int i = s1.lastIndexOf('.');
        if(-1 < i)
            s1 = s1.substring(i + 1);
        System.out.println(s1 + "\t" + s);
    }

    public void newSortColumn(String s, String s1)
    {
        int i = findColumn(s);
        if(-1 != i)
        {
            SortColumn sortcolumn = null;
            int j;
            for(j = 0; j < sortColumns.size(); j++)
            {
                sortcolumn = (SortColumn)sortColumns.get(j);
                if(sortcolumn.getName().equals(s))
                    break;
            }

            if(j == sortColumns.size())
            {
                sortcolumn = new SortColumn();
                sortColumns.add(sortcolumn);
                sortcolumn.setName(s);
            }
            sortcolumn.setSortOrder(SortOrder.fromString(s1));
        }
    }

    public void setSortNameOrder(String as[], String as1[])
    {
        sortColumns.removeAllElements();
        for(int i = 0; i < as.length; i++)
            newSortColumn(as[i], as1[i]);

        ArrayOfSortColumn arrayofsortcolumn = new ArrayOfSortColumn();
        arrayofsortcolumn.setSortColumn((SortColumn[])sortColumns.toArray(emptySortColumnArray));
        query.setSortColumnList(arrayofsortcolumn);
    }

    public void newFilterColumn(String s, String s1, String s2, boolean flag)
    {
        int i = findColumn(s);
        if(-1 != i)
        {
            FilterCriteria filtercriteria = new FilterCriteria();
            filtercriteria.setName(s);
            filtercriteria.setOperation(s1);
            filtercriteria.setPromptFilterCriteria(flag);
            filtercriteria.setValue(s2);
            FilterCriteria afiltercriteria[] = new FilterCriteria[filters.length + 1];
            for(int j = 0; j < filters.length; j++)
                afiltercriteria[j] = filters[j];

            afiltercriteria[filters.length] = filtercriteria;
            filters = afiltercriteria;
        }
    }

    private boolean filterExist(String s, String s1)
    {
        for(int i = 0; i < filters.length; i++)
            if(filters[i].getName().equals(s) && filters[i].getOperation().equals(s1))
                return true;

        return false;
    }

    public boolean addSelectValueList(ParameterDefinition parameterdefinition, String s)
    {
        if(parameterdefinition.getControlType() != ControlType.ControlListAllowNew)
            return false;
        String as[] = parameterdefinition.getSelectValueList().getString();
        for(int i = 0; i < as.length; i++)
            if(as[i].equals(s))
                return false;

        String as1[] = new String[as.length + 1];
        int j = 0;
        for(j = 0; j < as.length; j++)
            as1[j] = as[j];

        as1[j] = s;
        ArrayOfString arrayofstring = parameterdefinition.getSelectValueList();
        arrayofstring.setString(as1);
        return true;
    }

    private static FilterCriteria[] copyFilterCriterias(FilterCriteria afiltercriteria[])
    {
        if(null == afiltercriteria)
            return new FilterCriteria[0];
        FilterCriteria afiltercriteria1[] = new FilterCriteria[afiltercriteria.length];
        for(int i = 0; i < afiltercriteria.length; i++)
        {
            afiltercriteria1[i] = new FilterCriteria();
            afiltercriteria1[i].setName(afiltercriteria[i].getName());
            afiltercriteria1[i].setOperation(afiltercriteria[i].getOperation());
            afiltercriteria1[i].setValue(afiltercriteria[i].getValue());
            afiltercriteria1[i].setPromptFilterCriteria(afiltercriteria[i].isPromptFilterCriteria());
        }

        return afiltercriteria1;
    }

    private FilterCriteria[] newFilterLogic(FilterCriteria afiltercriteria[], FilterCriteria afiltercriteria1[])
    {
        if(null == afiltercriteria1)
            return afiltercriteria;
        for(int i = 0; i < afiltercriteria.length && i < afiltercriteria1.length; i++)
            if(afiltercriteria[i].isPromptFilterCriteria() != afiltercriteria1[i].isPromptFilterCriteria())
            {
                for(int j = 0; j < afiltercriteria.length; j++)
                    if(afiltercriteria[j].getName().equals(afiltercriteria[i].getName()))
                        afiltercriteria[j].setPromptFilterCriteria(afiltercriteria[i].isPromptFilterCriteria());

            }

        filters = new FilterCriteria[0];
        for(int k = 0; k < afiltercriteria.length && k < afiltercriteria1.length; k++)
            newFilterColumn(afiltercriteria[k].getName(), afiltercriteria[k].getOperation(), afiltercriteria[k].getValue(), afiltercriteria[k].isPromptFilterCriteria());

        return filters;
    }
    
    // DJM 3/4/04: Created ReplaceDisplayNames method to read column labels from an 
    // external database and replacing the column definition display names.  
    private void ReplaceDisplayNames()
    {
        boolean bExternLabels = false;
        String sReportName = "";
        if(null != parameterDefinitions)
        {
            // Get parameter values for AAA_ExternText and AAA_ReportName.  These two parameters
            // must exist in the report design if external labels are to be read.
            for(int i = 0; i < parameterDefinitions.length; i++) {
                if(parameterDefinitions[i].getName().equals("AAA_ExternText")) {
                    if(parameterDefinitions[i].getDefaultValue().toLowerCase().equals("true"))
                        bExternLabels = true;
                }
                // The AAA_ReportName parameter value is associated with the ReportName field in the database
                if(parameterDefinitions[i].getName().equals("AAA_ReportName")) {
                    sReportName = parameterDefinitions[i].getDefaultValue();
                }
            }
            // Check if column labels need to be replaced by external labels
            if (bExternLabels) {
                try {
					TextEntryList tel = new TextEntryList();
					tel.connectDB();
					String sDefaultLocale = "";
					String sLocalize = "LABELVALUE";
					String sLocalize2 = "VALUE1";
					tel.getDefaultLocale();
					while (tel.next()) {
                    	sDefaultLocale = tel.getString("VARVALUE");
					}
					if (sDefaultLocale.equals(getLocaleID())) {
						tel.setAttribute("mroLangCode", sDefaultLocale);
					} else {
						tel.setAttribute("mroLangCode", getLocaleID());
					}
                    tel.setAttribute("ReportName", sReportName);
                    tel.translate();
                    while (tel.next()) {
                        String sKeyValue = tel.getString("LABELKEY");
						String sTranslation = "";
						if (sDefaultLocale.equals(getLocaleID())) {
                        	sTranslation = tel.getString(sLocalize);
						} else {
							sTranslation = tel.getString(sLocalize2);
							if (sTranslation == null || sTranslation.equals("")) {
								sTranslation = tel.getString(sLocalize);
							}
						}
                        // Make replacements into column definition
                        int iCol = findDisplayColumn(sKeyValue);
                        if (iCol > -1) {
                            columnDefinitions[iCol].setDisplayName(sTranslation);
                        }
                    }
                }
                // Catch all exceptions.  Default display names from info obj (dox) will be used.
                catch (FileNotFoundException e) {}
                catch (ClassNotFoundException e) {}
                catch (SQLException e) {}
                catch (IOException e) {};
            }
            
        }
    }

    public void setQueryDefinition(Query query1, TableParameterListBean tableparameterlistbean)
    {
        queryDefinition = query1;
        if(null != query1)
        {
            columnDefinitions = query1.getAvailableColumnList().getColumnDefinition();
            Vector vector = new Vector();
            if(null != columnDefinitions)
            {
                for(int i = 0; i < columnDefinitions.length; i++)
                    if(columnDefinitions[i].isEnableFilter())
                        vector.add(columnDefinitions[i]);

            }
            columnFilters = (ColumnDefinition[])vector.toArray(emptyColumnDefinitionArray);
            ArrayOfString arrayofstring = query1.getSelectColumnList();
            String s = "";
            if(null != arrayofstring)
            {
                String as[] = arrayofstring.getString();
                if(null != as)
                {
                    for(int j = 0; j < as.length; j++)
                    {
                        if(j > 0)
                            s = s + ",";
                        s = s + as[j];
                    }

                }
            }
            setSelectedColumnAsString(s);
            Boolean boolean1 = query1.getPromptSelectColumnList();
            if(null == boolean1)
                boolean1 = Boolean.FALSE;
            query.setPromptSelectColumnList(boolean1);
            query.setGroupingList(queryDefinition.getGroupingList());
            query.setGroupingEnabled(queryDefinition.getGroupingEnabled());
            query.setPromptGroupingList(queryDefinition.getPromptGroupingList());
            if(null == queryDefinition.getPromptGroupingList())
                query.setPromptGroupingList(Boolean.FALSE);
            createGroupTree(query.getGroupingList());
            query.setAggregationList(queryDefinition.getAggregationList());
            query.setPromptAggregationList(queryDefinition.getPromptAggregationList());
            if(null == queryDefinition.getPromptAggregationList())
                query.setPromptAggregationList(Boolean.FALSE);
            query.setShowRowCount(queryDefinition.getShowRowCount());
            createSummaryList(query.getAggregationList());
            ArrayOfSortColumn arrayofsortcolumn = query1.getSortColumnList();
            sortColumns.clear();
            if(null != arrayofsortcolumn)
            {
                SortColumn asortcolumn[] = arrayofsortcolumn.getSortColumn();
                if(asortcolumn != null)
                {
                    for(int k = 0; k < asortcolumn.length; k++)
                    {
                        SortColumn sortcolumn = new SortColumn();
                        sortcolumn.setName(asortcolumn[k].getName());
                        sortcolumn.setSortOrder(asortcolumn[k].getSortOrder());
                        sortColumns.add(sortcolumn);
                    }

                }
                arrayofsortcolumn = new ArrayOfSortColumn();
                arrayofsortcolumn.setSortColumn((SortColumn[])sortColumns.toArray(new SortColumn[sortColumns.size()]));
                query.setSortColumnList(arrayofsortcolumn);
            }
            Boolean boolean2 = query1.getPromptSortColumnList();
            if(null == boolean2)
                boolean2 = Boolean.FALSE;
            query.setPromptSortColumnList(boolean2);
            updateParameterInfo(query1, tableparameterlistbean);
            ReplaceDisplayNames(); // DJM 3/4/04: Substitute new displayname from database lookup
            int l = 0;
            ArrayOfFilterCriteria arrayoffiltercriteria = query1.getFilterList();
            if(arrayoffiltercriteria != null)
            {
                ArrayOfFilterCriteria arrayoffiltercriteria1 = new ArrayOfFilterCriteria();
                filters = copyFilterCriterias(arrayoffiltercriteria.getFilterCriteria());
                arrayoffiltercriteria1.setFilterCriteria(filters);
                query.setFilterList(arrayoffiltercriteria1);
                for(int i1 = 0; i1 < filters.length; i1++)
                    if(filters[i1].isPromptFilterCriteria())
                        l++;

            }
            Boolean boolean3 = query1.getPromptOutputFormat();
            if(boolean3 != null)
                query.setPromptOutputFormat(boolean3);
            String s1 = query1.getOutputFormat();
            if(s1 != null)
                query.setOutputFormat(s1);
            String s2 = query1.getPageHeader();
            if(s2 != null)
                query.setPageHeader(s2);
            query.setAvailableColumnList(query1.getAvailableColumnList());
            query.setParameterDefinitionList(query1.getParameterDefinitionList());
            if(query1.getActuateQueryType() != null)
                query.setActuateQueryType(query1.getActuateQueryType());
            processDisplayedTab(promptedNonHiddenParameterCount, l);
        } else
        {
            dbg("setQueryDefinition(null)");
        }
    }

    public void setSelectedColumnAsString(String s)
    {
        int ai[] = new int[columnDefinitions.length];
        Arrays.fill(ai, -1);
        htSelectedColumns.clear();
        selectedColumns.removeAllElements();
        availableColumns.removeAllElements();
        StringTokenizer stringtokenizer = new StringTokenizer(s, ",");
        int i = stringtokenizer.countTokens();
        ColumnDefinition acolumndefinition[] = new ColumnDefinition[i];
        String as[] = new String[i];
        ArrayOfString arrayofstring = new ArrayOfString();
        arrayofstring.setString(as);
        query.setSelectColumnList(arrayofstring);
        for(int j = 0; j < i; j++)
        {
            String s1 = (String)stringtokenizer.nextElement();
            int l = findColumn(s1);
            if(-1 != l)
            {
                ai[l] = l;
                selectedColumns.add(columnDefinitions[l]);
                htSelectedColumns.put(columnDefinitions[l].getName(), columnDefinitions[l]);
                as[j] = columnDefinitions[l].getName();
            }
        }

        for(int k = 0; k < columnDefinitions.length; k++)
            if(-1 == ai[k])
                availableColumns.add(columnDefinitions[k]);

    }

    public String getSelectedColumnsAsString()
    {
        Vector vector = getSelectedColumns();
        String s = "";
        for(int i = 0; i < vector.size(); i++)
        {
            if(i > 0)
                s = s + ",";
            s = s + ((ColumnDefinition)vector.elementAt(i)).getName();
        }

        return s;
    }

    public String getDataSourceName()
    {
        return dataSourceName;
    }

    public void setDataSourceName(String s)
    {
        dataSourceName = s;
    }

    public Vector getAvailableColumns()
    {
        return availableColumns;
    }

    public Vector getSelectedColumns()
    {
        return selectedColumns;
    }

    public void setAvailableColumns(Vector vector)
    {
        availableColumns = vector;
    }

    public void setSelectedColumns(Vector vector)
    {
        selectedColumns = vector;
    }

    public ColumnDefinition[] getColumnDefinitions()
    {
        return columnDefinitions;
    }

    public boolean isPromptOutputFormat()
    {
        return query.getPromptOutputFormat().booleanValue();
    }

    public boolean isPromptSelectColumnList()
    {
        return query.getPromptSelectColumnList().booleanValue();
    }

    public boolean isPromptSortColumnList()
    {
        return query.getPromptSortColumnList().booleanValue();
    }

    public void setPromptOutputFormat(boolean flag)
    {
        query.setPromptOutputFormat(new Boolean(flag));
    }

    public void setPromptSelectColumnList(boolean flag)
    {
        query.setPromptSelectColumnList(new Boolean(flag));
    }

    public void setPromptSortColumnList(boolean flag)
    {
        query.setPromptSortColumnList(new Boolean(flag));
    }

    public Vector getSortColumns()
    {
        return sortColumns;
    }

    public void setOutputFormat(String s)
    {
        query.setOutputFormat(s);
    }

    public void setQueryDescription(String s)
    {
        queryFile.setDescription(s);
    }

    public String getOutputFormat()
    {
        return query.getOutputFormat();
    }

    public String getQueryDescription()
    {
        return queryFile.getDescription();
    }

    public String getQueryLocation()
    {
        return queryLocation;
    }

    public String getQueryName()
    {
        return queryName;
    }

    public void setQueryLocation(String s)
    {
        queryLocation = s.trim();
        if(s.length() > 0 && !s.endsWith("/"))
            s = s + "/";
        queryFile.setName(s + queryName);
    }

    public void setQueryName(String s)
    {
        queryName = s;
        queryFile.setName(queryLocation + s);
    }

    public FilterCriteria[] getFilters()
    {
        return filters;
    }

    public void setFilters(FilterCriteria afiltercriteria[])
    {
        ArrayOfFilterCriteria arrayoffiltercriteria = new ArrayOfFilterCriteria();
        arrayoffiltercriteria.setFilterCriteria(newFilterLogic(afiltercriteria, filters));
        filters = arrayoffiltercriteria.getFilterCriteria();
        query.setFilterList(arrayoffiltercriteria);
    }

    public void setFilters(FilterCriteria afiltercriteria[], Boolean boolean1)
    {
        if(null == afiltercriteria)
            return;
        if(null == filters)
            filters = new FilterCriteria[0];
        while(afiltercriteria.length > filters.length) 
            newFilterColumn(columnDefinitions[0].getName(), "=", "", false);
        if(Boolean.TRUE.equals(boolean1))
        {
            for(int i = 0; i < afiltercriteria.length; i++)
            {
                FilterCriteria filtercriteria = afiltercriteria[i];
                if(filters[i].isPromptFilterCriteria())
                {
                    FilterCriteria filtercriteria1 = filters[i];
                    if(filtercriteria1 != null)
                    {
                        filtercriteria1.setOperation(filtercriteria.getOperation());
                        filtercriteria1.setValue(filtercriteria.getValue());
                    }
                }
            }

        } else
        {
            setFilters(afiltercriteria);
        }
    }

    public ParameterDefinition[] getParameterDefinitions()
    {
        return parameterDefinitions;
    }

    public ParameterValue[] getParameters()
    {
        return parameters;
    }

    private void setParameters_old(ParameterValue aparametervalue[], Boolean boolean1)
    {
        for(int i = 0; i < aparametervalue.length; i++)
        {
            ParameterValue parametervalue = parameters[i];
            ParameterDefinition parameterdefinition = parameterDefinitions[i];
            boolean flag = addSelectValueList(parameterdefinition, aparametervalue[i].getValue());
            parametervalue.setValue(aparametervalue[i].getValue());
            if(Boolean.TRUE != boolean1 && null != parametervalue.getPromptParameter())
            {
                Boolean boolean2 = Boolean.TRUE != aparametervalue[i].getPromptParameter() ? Boolean.FALSE : Boolean.TRUE;
                parametervalue.setPromptParameter(boolean2);
            }
        }

        arrayOfParameterValue.setParameterValue(parameters);
        query.setReportParameterList(arrayOfParameterValue);
    }

    public void setParameters(ParameterValue aparametervalue[], Boolean boolean1)
    {
        for(int i = 0; i < aparametervalue.length; i++)
        {
            int j = findParameter(aparametervalue[i].getName());
            if(-1 != j)
            {
                ParameterValue parametervalue = parameters[j];
                ParameterDefinition parameterdefinition = parameterDefinitions[j];
                boolean flag = addSelectValueList(parameterdefinition, aparametervalue[i].getValue());
                parametervalue.setValue(aparametervalue[i].getValue());
                if(Boolean.TRUE != boolean1 && null != parametervalue.getPromptParameter())
                {
                    Boolean boolean2 = Boolean.TRUE != aparametervalue[i].getPromptParameter() ? Boolean.FALSE : Boolean.TRUE;
                    parametervalue.setPromptParameter(boolean2);
                }
            }
        }

        arrayOfParameterValue.setParameterValue(parameters);
        query.setReportParameterList(arrayOfParameterValue);
    }

    public Query getQuery()
    {
        if(query != null)
        {
            arrayOfParameterValue.setParameterValue(parameters);
            query.setReportParameterList(arrayOfParameterValue);
            ArrayOfParameterDefinition arrayofparameterdefinition = new ArrayOfParameterDefinition();
            arrayofparameterdefinition.setParameterDefinition(parameterDefinitions);
            query.setParameterDefinitionList(arrayofparameterdefinition);
            setGroups(query);
            setSummaries(query);
        }
        return query;
    }

    public NewFile getQueryFile()
    {
        return queryFile;
    }

    public String getPageHeader()
    {
        return query.getPageHeader();
    }

    public void setPageHeader(String s)
    {
        query.setPageHeader(s);
    }

    public String getDocumentLocation()
    {
        return documentLocation;
    }

    public String getDocumentName()
    {
        return newFile.getName();
    }

    public String getDocumentOutputLocation()
    {
        return documentOutputLocation;
    }

    public boolean isDocumentReplaceExisting()
    {
        return newFile.getReplaceExisting().booleanValue();
    }

    public boolean isDocumentSave()
    {
        return documentSave;
    }

    public String getDocumentVersionName()
    {
        return newFile.getVersionName();
    }

    public void setDocumentLocation(String s)
    {
        documentLocation = s;
    }

    public void setDocumentName(String s)
    {
        newFile.setName(s);
    }

    public void setDocumentOutputLocation(String s)
    {
        documentOutputLocation = s;
    }

    public void setDocumentReplaceExisting(boolean flag)
    {
        newFile.setReplaceExisting(new Boolean(flag));
    }

    public void setDocumentSave(boolean flag)
    {
        documentSave = flag;
    }

    public void setDocumentVersionName(String s)
    {
        newFile.setVersionName(s);
    }

    public String[] getDisplayedTabs()
    {
        return displayedTabs;
    }

    public String getEndDate()
    {
        return endDate;
    }

    public String getJobName()
    {
        return jobName;
    }

    public String getOnceDate()
    {
        return onceDate;
    }

    public String getOnceTime()
    {
        return onceTime;
    }

    public String getRecurringDay()
    {
        return recurringDay;
    }

    public String getRecurringTime()
    {
        return recurringTime;
    }

    public String getScheduleType()
    {
        return scheduleType;
    }

    public String getStartDate()
    {
        return startDate;
    }

    public boolean isUseEndDateTime()
    {
        return useEndDateTime;
    }

    public boolean isUseStartDateTime()
    {
        return useStartDateTime;
    }

    public void setEndDate(String s)
    {
        endDate = s;
    }

    public void setJobName(String s)
    {
        jobName = s;
    }

    public void setOnceDate(String s)
    {
        onceDate = s;
    }

    public void setOnceTime(String s)
    {
        onceTime = s;
    }

    public void setRecurringDay(String s)
    {
        recurringDay = s;
    }

    public void setRecurringTime(String s)
    {
        recurringTime = s;
    }

    public void setScheduleType(String s)
    {
        scheduleType = s;
    }

    public void setStartDate(String s)
    {
        startDate = s;
    }

    public void setUseEndDateTime(boolean flag)
    {
        useEndDateTime = flag;
    }

    public void setUseStartDateTime(boolean flag)
    {
        useStartDateTime = flag;
    }

    public boolean isSubmitQuery()
    {
        return submitQuery;
    }

    public void setSubmitQuery(boolean flag)
    {
        submitQuery = flag;
    }

    public void setDisplayedTabs(String as[])
    {
        displayedTabs = as;
    }

    public String getSaveName()
    {
        String s = queryFile.getName();
        if(!s.toLowerCase().endsWith(".dov"))
            return s + ".dov";
        else
            return s;
    }

    public ColumnDefinition[] getColumnFilters()
    {
        return columnFilters;
    }

    public boolean isForRunning()
    {
        return forRunning;
    }

    public void setForRunning(boolean flag)
    {
        forRunning = flag;
    }

    public boolean isPromptFilterPage()
    {
        return promptFilterPage;
    }

    public void setPromptFilterPage(boolean flag)
    {
        promptFilterPage = flag;
    }

    public void setQuery(Query query1)
    {
        query = query1;
    }

    public String getTimeZoneName()
    {
        return timeZoneName;
    }

    public void setTimeZoneName(String s)
    {
        timeZoneName = s;
    }

    public String getJobId()
    {
        return jobId;
    }

    public void setJobId(String s)
    {
        jobId = s;
    }

    public void setViewInNewWindow(boolean flag)
    {
        viewInNewWindow = flag;
    }

    public boolean getViewInNewWindow()
    {
        return viewInNewWindow;
    }

    public String getNewFileName()
    {
        boolean flag = "personal".equalsIgnoreCase(getDocumentOutputLocation());
        String s = flag ? "~/" + getDocumentName() : AcCreateQueryAction.createFileName(getDocumentLocation(), getDocumentName());
        if(!s.toLowerCase().endsWith(".doi"))
            s = s + ".doi";
        return s;
    }

    private DataType getColumnDataType(String s)
    {
        int i = findColumn(s);
        if(i != -1)
        {
            ColumnDefinition columndefinition = getColumnDefinitions()[i];
            return columndefinition.getDataType();
        } else
        {
            return null;
        }
    }

    public String[][] getFilterOperators()
    {
        FilterCriteria afiltercriteria[] = getFilters();
        if(afiltercriteria == null)
            return new String[0][];
        String as[][] = new String[afiltercriteria.length][];
        for(int i = 0; i < afiltercriteria.length; i++)
        {
            DataType datatype = getColumnDataType(afiltercriteria[i].getName());
            if(datatype != null)
            {
                if(DataType.String.equals(datatype))
                    as[i] = operatorsString;
                else
                if(DataType.Boolean.equals(datatype))
                    as[i] = operatorsBoolean;
                else
                    as[i] = operatorsDefault;
            } else
            {
                StaticFuncs.error("Class CreateQueryBean", "Filter item = " + afiltercriteria[i].getName() + " not found in the AvailableColumnList");
            }
        }

        return as;
    }

    public int getVisibleParameterCount()
    {
        return visibleParameterCount;
    }

    public void setVisibleParameterCount(int i)
    {
        visibleParameterCount = i;
    }

    public String getHeadline()
    {
        return headline;
    }

    public void setHeadline(String s)
    {
        headline = s;
    }

    public boolean isProgressiveViewing()
    {
        return progressiveViewing;
    }

    public void setProgressiveViewing(boolean flag)
    {
        progressiveViewing = flag;
    }

    public int getPriority()
    {
        return priority;
    }

    public void setPriority(int i)
    {
        priority = i;
    }

    public NewFile getNewFile()
    {
        return newFile;
    }

    public void setNewFile(NewFile newfile)
    {
        newFile = newfile;
    }

    public String[] getNotifyChannelsByName()
    {
        return notifyChannelsByName;
    }

    public String[] getNotifyGroupsByName()
    {
        return notifyGroupsByName;
    }

    public String[] getNotifyUsersByName()
    {
        return notifyUsersByName;
    }

    public void setNotifyChannelsByName(String as[])
    {
        notifyChannelsByName = as;
    }

    public void setNotifyGroupsByName(String as[])
    {
        notifyGroupsByName = as;
    }

    public void setNotifyUsersByName(String as[])
    {
        notifyUsersByName = as;
    }

    public boolean isProgressiveViewingLogic()
    {
        return "DHTML".equalsIgnoreCase(getOutputFormat()) && progressiveViewing;
    }

    public int getVisiblePromptParameterCount()
    {
        return visiblePromptParameterCount;
    }

    public String getColumnDefinitionsJSArray()
    {
        String s = "\n";
        if(null != columnDefinitions)
        {
            for(int i = 0; i < columnDefinitions.length; i++)
                s = s + "columnDefinitions[" + i + "] = '" + columnDefinitions[i].getName() + "';\n";

        }
        return s;
    }

    private final void updateParameterInfo(Query query1, TableParameterListBean tableparameterlistbean)
    {
        tableparameterlistbean.clearTables();
        tableparameterlistbean.setExecutableID(getDataSourceName());
        ArrayOfParameterDefinition arrayofparameterdefinition = query1.getParameterDefinitionList();
        alStructureNames = new LinkedList();
        if(null == arrayofparameterdefinition)
        {
            parameterDefinitions = emptyParameterDefinitionArray;
            origParameterDefinitions = emptyParameterDefinitionArray;
            parameters = new ParameterValue[0];
            return;
        }
        ArrayList arraylist = new ArrayList(10);
        Hashtable hashtable = new Hashtable(10);
        origParameterDefinitions = arrayofparameterdefinition.getParameterDefinition();
        visibleParameterCount = 0;
        int i = 0;
        for(int j = 0; j < origParameterDefinitions.length; j++)
            if(origParameterDefinitions[j].getDataType().equals(DataType.Structure))
            {
                if(origParameterDefinitions[j].getRecordDefinition() != null)
                {
                    com.actuate.schemas.FieldDefinition afielddefinition[] = origParameterDefinitions[j].getRecordDefinition().getFieldDefinition();
                    Record arecord[] = null;
                    if(origParameterDefinitions[j].getDefaultTableValues() != null)
                        arecord = origParameterDefinitions[j].getDefaultTableValues().getRecord();
                    if(afielddefinition != null)
                    {
                        alStructureNames.add(origParameterDefinitions[j].getName());
                        for(int i1 = 0; i1 < afielddefinition.length; i1++)
                        {
                            ParameterDefinition parameterdefinition = null;
                            if(arecord == null)
                                parameterdefinition = StaticFuncs.constructParameterDefinition(afielddefinition[i1], origParameterDefinitions[j].getName(), null);
                            else
                                parameterdefinition = StaticFuncs.constructParameterDefinition(afielddefinition[i1], origParameterDefinitions[j].getName(), arecord[0]);
                            arraylist.add(parameterdefinition);
                            if(!parameterdefinition.getIsHidden().booleanValue())
                                visibleParameterCount++;
                            ParameterValue parametervalue1 = StaticFuncs.constructParameterValue(parameterdefinition);
                            hashtable.put(parametervalue1.getGroup() + "." + parametervalue1.getName(), parametervalue1);
                            i++;
                        }

                    }
                }
            } else
            {
                if(origParameterDefinitions[j].getDataType().equals(DataType.Table))
                {
                    tableparameterlistbean.addTable(origParameterDefinitions[j]);
                    visibleParameterCount++;
                } else
                {
                    if(!origParameterDefinitions[j].getIsHidden().booleanValue())
                        visibleParameterCount++;
                    if(origParameterDefinitions[j].getGroup() != null && origParameterDefinitions[j].getGroup().length() > 0)
                        i++;
                }
                arraylist.add(origParameterDefinitions[j]);
                ParameterValue parametervalue = StaticFuncs.constructParameterValue(origParameterDefinitions[j]);
                hashtable.put(parametervalue.getGroup() + "." + parametervalue.getName(), parametervalue);
            }

        parameterDefinitions = new ParameterDefinition[arraylist.size()];
        int k = 0;
        int l = parameterDefinitions.length - i;
        for(int j1 = 0; j1 < parameterDefinitions.length; j1++)
        {
            ParameterDefinition parameterdefinition1 = (ParameterDefinition)arraylist.get(j1);
            if(parameterdefinition1.getGroup() != null && parameterdefinition1.getGroup().length() > 0)
                parameterDefinitions[l++] = parameterdefinition1;
            else
                parameterDefinitions[k++] = parameterdefinition1;
        }

        ArrayOfParameterValue arrayofparametervalue = query1.getReportParameterList();
        if(arrayofparametervalue != null)
        {
            ParameterValue aparametervalue[] = arrayofparametervalue.getParameterValue();
            if(aparametervalue != null)
            {
                for(int l1 = 0; l1 < aparametervalue.length; l1++)
                    if(alStructureNames.indexOf(aparametervalue[l1].getName()) != -1)
                    {
                        if(aparametervalue[l1].getTableValue() != null)
                        {
                            Record arecord1[] = aparametervalue[l1].getTableValue().getRecord();
                            if(arecord1 != null && arecord1.length > 0)
                            {
                                FieldValue afieldvalue[] = arecord1[0].getFieldValue();
                                if(afieldvalue != null)
                                {
                                    for(int i2 = 0; i2 < afieldvalue.length; i2++)
                                    {
                                        ParameterValue parametervalue4 = (ParameterValue)hashtable.get(aparametervalue[l1].getName() + "." + afieldvalue[i2].getName());
                                        parametervalue4.setPromptParameter(aparametervalue[l1].getPromptParameter());
                                        if(parametervalue4.getPromptParameter() == null)
                                            parametervalue4.setPromptParameter(Boolean.FALSE);
                                        if(afieldvalue[i2].getValue() != null)
                                            parametervalue4.setValue(afieldvalue[i2].getValue());
                                    }

                                }
                            }
                        }
                    } else
                    {
                        ParameterDefinition parameterdefinition2 = tableparameterlistbean.getTableDefinition(aparametervalue[l1].getName());
                        ParameterValue parametervalue3 = (ParameterValue)hashtable.get(aparametervalue[l1].getGroup() + "." + aparametervalue[l1].getName());
                        parametervalue3.setPromptParameter(aparametervalue[l1].getPromptParameter());
                        if(parametervalue3.getPromptParameter() == null)
                            parametervalue3.setPromptParameter(Boolean.FALSE);
                        if(parameterdefinition2 != null)
                        {
                            if(aparametervalue[l1].getTableValue() != null)
                            {
                                Record arecord2[] = aparametervalue[l1].getTableValue().getRecord();
                                if(arecord2 != null && arecord2.length > 0)
                                {
                                    tableparameterlistbean.clearAllRows(aparametervalue[l1].getName());
                                    tableparameterlistbean.addRows(aparametervalue[l1].getName(), arecord2);
                                }
                            }
                        } else
                        if(aparametervalue[l1].getValue() != null)
                            parametervalue3.setValue(aparametervalue[l1].getValue());
                    }

            }
        }
        parameters = new ParameterValue[parameterDefinitions.length];
        promptedNonHiddenParameterCount = 0;
        visiblePromptParameterCount = 0;
        for(int k1 = 0; k1 < parameterDefinitions.length; k1++)
        {
            ParameterValue parametervalue2 = (ParameterValue)hashtable.get(parameterDefinitions[k1].getGroup() + "." + parameterDefinitions[k1].getName());
            if(parametervalue2 != null && Boolean.TRUE == parametervalue2.getPromptParameter() && Boolean.FALSE == parameterDefinitions[k1].getIsHidden())
            {
                promptedNonHiddenParameterCount++;
                visiblePromptParameterCount++;
            }
            parameters[k1] = parametervalue2;
        }

    }

    public Query getUpdatedQuery(AcRequestHandlerBean acrequesthandlerbean)
    {
        if(query != null)
        {
            arrayOfParameterValue = AcBaseJobAdapter.constructParameters(alStructureNames, parameters, acrequesthandlerbean);
            query.setReportParameterList(arrayOfParameterValue);
            ArrayOfParameterDefinition arrayofparameterdefinition = new ArrayOfParameterDefinition();
            arrayofparameterdefinition.setParameterDefinition(origParameterDefinitions);
            query.setParameterDefinitionList(arrayofparameterdefinition);
            setGroups(query);
            setSummaries(query);
            return query;
        } else
        {
            return null;
        }
    }

    public LinkedList getStructureNames()
    {
        return alStructureNames;
    }

    public String getNotificationAttachment()
    {
        return notificationAttachment;
    }

    public boolean isNotify()
    {
        return notify;
    }

    public void setNotificationAttachment(String s)
    {
        notificationAttachment = s;
    }

    public void setNotify(boolean flag)
    {
        notify = flag;
    }

    public Vector getColumnsAvailableToGroup()
    {
        Vector vector = new Vector();
        for(Iterator iterator = selectedColumns.iterator(); iterator.hasNext();)
        {
            ColumnDefinition columndefinition = (ColumnDefinition)iterator.next();
            if(groups.findByName(columndefinition.getName()) == null)
                vector.add(columndefinition);
        }

        return vector;
    }

    public HtmlTree getGroups()
    {
        return groups;
    }

    public void addGroup(String as[])
    {
        if(as != null && as.length > 0)
        {
            HtmlTreeNode htmltreenode = selectedNode;
            if(htmltreenode == null)
                htmltreenode = groups.getRoot();
            int i = -1;
            if(htmltreenode.getDepth() > 1)
            {
                i = htmltreenode.getParentNode().getIndex(htmltreenode);
                htmltreenode = htmltreenode.getParentNode();
            }
            int j = 1;
            if(htmltreenode.getDepth() == 0)
            {
                HtmlTreeNode htmltreenode1 = new HtmlTreeNode("group");
                htmltreenode1.setName(as[0]);
                ColumnDefinition columndefinition = (ColumnDefinition)htSelectedColumns.get(as[0]);
                if(columndefinition != null)
                {
                    htmltreenode1.setLabel(columndefinition.getDisplayName());
                    htmltreenode1.setData("ASC");
                }
                htmltreenode.addChild(htmltreenode1);
                htmltreenode.setExpandable(true);
                int l = findColumn(as[0]);
                if(l > -1)
                    htmltreenode1.setLabel(columnDefinitions[l].getDisplayName());
                htmltreenode = htmltreenode1;
            } else
            {
                j = 0;
            }
            for(int k = j; k < as.length; k++)
            {
                HtmlTreeNode htmltreenode2 = new HtmlTreeNode("columnHeading");
                htmltreenode2.setName(as[k]);
                if(i < 0)
                    htmltreenode.addChild(htmltreenode2);
                else
                    htmltreenode.insertChildAfter((i + k) - j, htmltreenode2);
                int i1 = findColumn(as[k]);
                if(i1 > -1)
                    htmltreenode2.setLabel(columnDefinitions[i1].getDisplayName());
            }

            if(htmltreenode.getChildCount() > 0)
            {
                htmltreenode.setExpandable(true);
                htmltreenode.setOpened(true);
            }
        }
    }

    public HtmlTreeNode getSelectedNode()
    {
        return selectedNode;
    }

    public void setSelectedNode(HtmlTreeNode htmltreenode)
    {
        if(selectedNode != null)
            selectedNode.setSelected(false);
        selectedNode = htmltreenode;
        if(selectedNode != null)
            selectedNode.setSelected(true);
    }

    public boolean isAllowGroupingChangeAtRuntime()
    {
        if(query.getPromptGroupingList() == null)
            return false;
        else
            return query.getPromptGroupingList().booleanValue();
    }

    public void setAllowGroupingChangeAtRuntime(boolean flag)
    {
        query.setPromptGroupingList(new Boolean(flag));
    }

    public Vector getSummaryColumns()
    {
        if(summaryColumns == null || summaryColumns.size() == 0)
            refreshSummaryColumns();
        return summaryColumns;
    }

    public void refreshSummaryColumns()
    {
        if(summaryColumns == null)
            summaryColumns = new Vector(10);
        for(Iterator iterator = selectedColumns.iterator(); iterator.hasNext();)
        {
            ColumnDefinition columndefinition = (ColumnDefinition)iterator.next();
            if(columndefinition.getDataType().equals(DataType.Currency) || columndefinition.getDataType().equals(DataType.Integer) || columndefinition.getDataType().equals(DataType.Double) || columndefinition.getDataType().equals(DataType.Date))
            {
                Iterator iterator1 = summaryColumns.iterator();
                SummaryBean summarybean1 = null;
                while(iterator1.hasNext()) 
                {
                    SummaryBean summarybean2 = (SummaryBean)iterator1.next();
                    if(summarybean2.getColumnName().equals(columndefinition.getName()))
                    {
                        summarybean1 = summarybean2;
                        summarybean1.setState(2);
                        break;
                    }
                }
                if(summarybean1 == null)
                {
                    summarybean1 = new SummaryBean();
                    summarybean1.setColumnName(columndefinition.getName());
                    summarybean1.setDisplayName(columndefinition.getDisplayName());
                    summarybean1.setFunction("");
                    summaryColumns.addElement(summarybean1);
                    summarybean1.setState(2);
                    summarybean1.setDataType(columndefinition.getDataType().getValue());
                }
                if(groups.findByName(summarybean1.getColumnName()) != null)
                    summarybean1.setActive(false);
                else
                    summarybean1.setActive(true);
            }
        }

        for(int i = summaryColumns.size() - 1; i >= 0; i--)
        {
            SummaryBean summarybean = (SummaryBean)summaryColumns.elementAt(i);
            if(summarybean.getState() != 2)
                summaryColumns.removeElementAt(i);
            else
                summarybean.setState(0);
        }

    }

    public void updateSummaryColumns(Vector vector)
    {
        if(vector != null)
        {
            for(int i = 0; i < vector.size(); i++)
            {
                SummaryBean summarybean = (SummaryBean)vector.elementAt(i);
                SummaryBean summarybean1 = (SummaryBean)summaryColumns.elementAt(i);
                summarybean1.setFunction(summarybean.getFunction());
            }

        }
    }

    public boolean isAllowSummaryChangeAtRuntime()
    {
        if(query == null || query.getPromptAggregationList() == null)
            return false;
        else
            return query.getPromptAggregationList().booleanValue();
    }

    public void setAllowSummaryChangeAtRuntime(boolean flag)
    {
        query.setPromptAggregationList(new Boolean(flag));
    }

    public boolean isShowRowCountsInTotal()
    {
        if(query == null || query.getShowRowCount() == null)
            return false;
        else
            return query.getShowRowCount().booleanValue();
    }

    public void setShowRowCountsInTotal(boolean flag)
    {
        query.setShowRowCount(new Boolean(flag));
    }

    public void refreshGroups()
    {
        for(Iterator iterator = groups.iterator(); iterator.hasNext();)
        {
            HtmlTreeNode htmltreenode = (HtmlTreeNode)iterator.next();
            if(htmltreenode.getDepth() > 0 && htSelectedColumns.get(htmltreenode.getName()) == null)
                iterator.remove();
        }

    }

    public void refreshSortColumns()
    {
        Vector vector = getSortColumns();
        if(vector != null)
        {
            for(int i = vector.size() - 1; i >= 0; i--)
            {
                SortColumn sortcolumn = (SortColumn)vector.elementAt(i);
                ColumnDefinition columndefinition = (ColumnDefinition)htSelectedColumns.get(sortcolumn.getName());
                if(columndefinition == null)
                    vector.removeElementAt(i);
                else
                if(groups.findByName(sortcolumn.getName()) != null)
                    vector.removeElementAt(i);
            }

        }
    }

    public void updateGroupSortOrder(List list)
    {
        if(list != null)
        {
            List list1 = groups.getRoot().getChildList();
            for(int i = 0; i < list.size(); i++)
            {
                HtmlTreeNode htmltreenode = (HtmlTreeNode)list1.get(i);
                HtmlTreeNode htmltreenode1 = (HtmlTreeNode)list.get(i);
                htmltreenode.setData(htmltreenode1.getData());
            }

        }
    }

    public Collection getSortableColumns()
    {
        LinkedList linkedlist = new LinkedList();
        if(columnDefinitions != null)
        {
            for(int i = 0; i < columnDefinitions.length; i++)
            {
                ColumnDefinition columndefinition = columnDefinitions[i];
                boolean flag = true;
                if(groups != null)
                    flag = groups.findByName(columndefinition.getName()) == null;
                if(flag)
                    linkedlist.add(columndefinition);
            }

        }
        return linkedlist;
    }

    private void setSummaries(Query query1)
    {
        ArrayOfAggregation arrayofaggregation = new ArrayOfAggregation();
        if(summaryColumns != null && summaryColumns.size() > 0)
        {
            Vector vector = new Vector();
            boolean flag = false;
            for(Iterator iterator = summaryColumns.iterator(); iterator.hasNext();)
            {
                SummaryBean summarybean = (SummaryBean)iterator.next();
                if(summarybean.isActive() && summarybean.getFunction().trim().length() > 0)
                {
                    Aggregation aggregation = new Aggregation();
                    aggregation.setColumnName(summarybean.getColumnName());
                    ArrayOfString arrayofstring = new ArrayOfString();
                    arrayofstring.setString(new String[] {
                        summarybean.getFunction()
                    });
                    aggregation.setAggregationFunctions(arrayofstring);
                    vector.addElement(aggregation);
                }
            }

            if(vector.size() > 0)
            {
                Aggregation aaggregation[] = (Aggregation[])vector.toArray(new Aggregation[0]);
                arrayofaggregation.setAggregation(aaggregation);
            }
        }
        query1.setAggregationList(arrayofaggregation);
    }

    private void setGroups(Query query1)
    {
        ArrayOfGrouping arrayofgrouping = new ArrayOfGrouping();
        if(groups.getRoot() != null)
        {
            Collection collection = groups.getRoot().getChildren();
            if(collection != null && collection.size() > 0)
            {
                Grouping agrouping[] = new Grouping[collection.size()];
                Iterator iterator = collection.iterator();
                int i = 0;
                while(iterator.hasNext()) 
                {
                    HtmlTreeNode htmltreenode = (HtmlTreeNode)iterator.next();
                    Grouping grouping = new Grouping();
                    grouping.setGroupKey(htmltreenode.getName());
                    grouping.setGroupSortOrder(GroupSortOrder.fromValue((String)htmltreenode.getData()));
                    agrouping[i++] = grouping;
                    Collection collection1 = htmltreenode.getChildren();
                    if(collection1 != null && collection1.size() > 0)
                    {
                        String as[] = new String[collection1.size()];
                        int j = 0;
                        for(Iterator iterator1 = collection1.iterator(); iterator1.hasNext();)
                            as[j++] = ((HtmlTreeNode)iterator1.next()).getName();

                        ArrayOfString arrayofstring = new ArrayOfString();
                        arrayofstring.setString(as);
                        grouping.setGroupHeadingFields(arrayofstring);
                    }
                }
                arrayofgrouping.setGrouping(agrouping);
            }
        }
        query1.setGroupingList(arrayofgrouping);
    }

    public boolean isGroupingEnabled()
    {
        if(query == null || query.getGroupingEnabled() == null)
            return false;
        else
            return query.getGroupingEnabled().booleanValue();
    }

    private void createSummaryList(ArrayOfAggregation arrayofaggregation)
    {
        if(summaryColumns == null)
            summaryColumns = new Vector(10);
        summaryColumns.clear();
        if(arrayofaggregation != null)
        {
            Aggregation aaggregation[] = arrayofaggregation.getAggregation();
            if(aaggregation != null)
            {
                for(int i = 0; i < aaggregation.length; i++)
                {
                    SummaryBean summarybean = new SummaryBean();
                    summarybean.setColumnName(aaggregation[i].getColumnName());
                    ColumnDefinition columndefinition = (ColumnDefinition)htSelectedColumns.get(summarybean.getColumnName());
                    if(columndefinition != null)
                    {
                        summarybean.setFunction(aaggregation[i].getAggregationFunctions().getString(0));
                        summarybean.setDisplayName(columndefinition.getDisplayName());
                        summaryColumns.addElement(summarybean);
                    }
                }

            }
        }
    }

    private void createGroupTree(ArrayOfGrouping arrayofgrouping)
    {
        if(groups == null)
            groups = new HtmlTree();
        HtmlTreeNode htmltreenode = groups.getRoot();
        htmltreenode.getChildren().clear();
        if(arrayofgrouping != null)
        {
            Grouping agrouping[] = arrayofgrouping.getGrouping();
            if(agrouping != null)
            {
                htmltreenode.setExpandable(true);
                for(int i = 0; i < agrouping.length; i++)
                {
                    ColumnDefinition columndefinition = (ColumnDefinition)htSelectedColumns.get(agrouping[i].getGroupKey());
                    if(columndefinition != null)
                    {
                        HtmlTreeNode htmltreenode1 = new HtmlTreeNode(agrouping[i].getGroupKey());
                        htmltreenode1.setLabel(columndefinition.getDisplayName());
                        htmltreenode1.setData(agrouping[i].getGroupSortOrder().getValue());
                        htmltreenode.addChild(htmltreenode1);
                        ArrayOfString arrayofstring = agrouping[i].getGroupHeadingFields();
                        if(arrayofstring != null)
                        {
                            String as[] = arrayofstring.getString();
                            if(as != null && as.length > 0)
                            {
                                for(int j = 0; j < as.length; j++)
                                {
                                    ColumnDefinition columndefinition1 = (ColumnDefinition)htSelectedColumns.get(as[j]);
                                    if(columndefinition1 != null)
                                    {
                                        HtmlTreeNode htmltreenode2 = new HtmlTreeNode(as[j]);
                                        htmltreenode2.setLabel(columndefinition1.getDisplayName());
                                        htmltreenode1.addChild(htmltreenode2);
                                    }
                                }

                                htmltreenode1.setExpandable(true);
                            }
                        }
                    }
                }

            }
        }
    }

    public boolean isAnyGroupPresent()
    {
        if(getGroups() != null && getGroups().getRoot() != null)
            return getGroups().getRoot().getChildCount() > 0;
        else
            return false;
    }

    public boolean isAnySummaryActive()
    {
        if(getSummaryColumns() != null)
        {
            for(Iterator iterator = getSummaryColumns().iterator(); iterator.hasNext();)
            {
                SummaryBean summarybean = (SummaryBean)iterator.next();
                if(summarybean.isActive())
                    return true;
            }

        }
        return false;
    }

	// DJM 3/4/04: Added localeID property for external column label lookup in database
    /** Getter for property localeID.
     * @return Value of property localeID.
     *
     */
    public String getLocaleID() {
        return this.localeID;
    }
    
    // DJM 3/4/04: Added localeID property for external column label lookup in database
    /** Setter for property localeID.
     * @param localeID New value of property localeID.
     *
     */
    public void setLocaleID(String localeID) {
        this.localeID = localeID;
    }
    
    private static final SortColumn emptySortColumnArray[] = new SortColumn[0];
    private static final ParameterDefinition emptyParameterDefinitionArray[] = new ParameterDefinition[0];
    private static final String emptyStringArray[] = new String[0];
    private static final ColumnDefinition emptyColumnDefinitionArray[] = new ColumnDefinition[0];
    protected String dataSourceName;
    protected Query queryDefinition;
    protected Query query;
    protected NewFile queryFile;
    private ColumnDefinition columnDefinitions[];
    private ParameterDefinition parameterDefinitions[];
    private ParameterDefinition origParameterDefinitions[];
    private LinkedList alStructureNames;
    private ColumnDefinition columnFilters[];
    private boolean forRunning;
    private boolean promptFilterPage;
    private boolean viewInNewWindow;
    private int visibleParameterCount;
    private int visiblePromptParameterCount;
    private int promptedNonHiddenParameterCount;
    private String displayedTabs[];
    private String jobId;
    private boolean submitQuery;
    private String timeZoneName;
    private String jobName;
    private String scheduleType;
    private String onceDate;
    private String onceTime;
    private String recurringDay;
    private String recurringTime;
    private boolean useStartDateTime;
    private boolean useEndDateTime;
    private String startDate;
    private String endDate;
    private Vector availableColumns;
    private Vector selectedColumns;
    private Hashtable htSelectedColumns;
    private Vector sortColumns;
    private ParameterValue parameters[];
    private FilterCriteria filters[];
    private String queryName;
    private String queryLocation;
    private boolean documentSave;
    private String documentOutputLocation;
    private NewFile newFile;
    private String documentLocation;
    private String headline;
    private boolean progressiveViewing;
    private int priority;
    private String notifyUsersByName[];
    private String notifyGroupsByName[];
    private String notifyChannelsByName[];
    private boolean notify;
    private String notificationAttachment;
    private Vector columnsAvailableToGroup;
    private HtmlTree groups;
    private HtmlTreeNode selectedNode;
    private Vector summaryColumns;
    ArrayOfParameterValue arrayOfParameterValue;
    public static final String operatorsString[] = {
        "=", "<", "<=", ">", ">=", "<>", "LIKE", "NOT LIKE", "IS NULL", "IS NOT NULL"
    };
    public static final String operatorsBoolean[] = {
        "=", "IS NULL", "IS NOT NULL"
    };
    public static final String operatorsDefault[] = {
        "=", "<", "<=", ">", ">=", "<>", "IS NULL", "IS NOT NULL"
    };

    // DJM 3/4/04: Added for looking up external column labels from a database using locale and reportname
    /** Holds value of property localeID. */
    private String localeID;

}